{{ $appSection := "backend" -}}
{{ $appName := (index . "Values" $appSection "name") -}}
{{- if index . "Values" $appSection "enabled" -}}
apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ $appName }}
  annotations:
    {{- include "golemioBi.annotations" . | nindent 4 }}
  labels:
    app.kubernetes.io/name: {{ $appName }}
    backstage.io/kubernetes-id: {{ $appName }}
    {{- include "golemioBi.labels" . | nindent 4 }}
spec:
  replicas: {{ index . "Values" $appSection "replicas" }}
  strategy: {{- include "golemioBi.rollingUpdate" (index . "Values" $appSection) | nindent 4 }}
  selector:
    matchLabels:
      app.kubernetes.io/name: {{ $appName }}
      {{- include "golemioBi.selectorLabels" . | nindent 6 }}
  template:
    metadata:
      annotations:
        {{- include "golemioBi.annotations" . | nindent 8 }}
      labels:
        app.kubernetes.io/name: {{ $appName }}
        backstage.io/kubernetes-id: {{ $appName }}
        {{- include "golemioBi.labels" . | nindent 8 }}
    spec:
      automountServiceAccountToken: false
      {{- include "golemioBi.imagePullSecrets" (list . .Values.global.imagePullSecrets ) | nindent 6 }}
      containers:
        - name: {{ $appName }}
          image: {{ include "golemioBi.imageName" (list . $appSection) | quote }}
          imagePullPolicy: {{ .Values.global.pullPolicy }}
          ports:
            - containerPort: {{ index . "Values" $appSection "port" }}
          env:
            - name: AUTH_STRATEGY
              value: {{ index . "Values" $appSection "auth" "strategy" }}
            - name: AUTH_URL
              value: {{ index . "Values" $appSection "auth" "url" }}
            {{- if index .Values $appSection "azure" "enabled" }}
            - name: AZURE_BLOB_STORAGE_CONN
              valueFrom:
                secretKeyRef:
                  name: {{ .Values.global.secretName }}
                  key: azureBlobStorageConn
            - name: AZURE_BLOB_STORAGE_CONTAINER_NAME
              value: {{ index . "Values" $appSection "azure" "container" | quote }}
            {{- end }}
            - name: LOG_LEVEL
              value: warn
            - name: POSTGRES_CONN
              valueFrom:
                secretKeyRef:
                  name: {{ .Values.global.secretName }}
                  key: postgresConn
            - name: POSTGRES_POOL_MAX_CONNECTIONS
              value: "10"
            - name: PORT
              value: {{ index . "Values" $appSection "port" | quote }}
            - name: POWER_BI_CLIENT_ID
              valueFrom:
                secretKeyRef:
                  name: {{ .Values.global.secretName }}
                  key: power-bi-client-id
            - name: POWER_BI_PASSWORD
              valueFrom:
                secretKeyRef:
                  name: {{ .Values.global.secretName }}
                  key: power-bi-password
            - name: POWER_BI_USERNAME
              valueFrom:
                secretKeyRef:
                  name: {{ .Values.global.secretName }}
                  key: power-bi-username
            - name: POWER_BI_TENANT_ID
              valueFrom:
                secretKeyRef:
                  key: power-bi-tenant-id
                  name: {{ .Values.global.secretName | quote }}
            - name: POWER_BI_CLIENT_SECRET
              valueFrom:
                secretKeyRef:
                  key: power-bi-client-secret
                  name: {{ .Values.global.secretName | quote }}
            - name: MAILER_ENABLED
              value: 'true'
            - name: MAILER_HOST
              valueFrom:
                secretKeyRef:
                  name: {{ .Values.global.secretName }}
                  key: smtp-host
            - name: MAILER_PORT
              valueFrom:
                secretKeyRef:
                  name: {{ .Values.global.secretName }}
                  key: smtp-port
            - name: MAILER_USERNAME
              valueFrom:
                secretKeyRef:
                  name: {{ .Values.global.secretName }}
                  key: smtp-user
            - name: MAILER_PASSWORD
              valueFrom:
                secretKeyRef:
                  name: {{ .Values.global.secretName }}
                  key: smtp-password
            - name: MAILER_FROM
              valueFrom:
                secretKeyRef:
                  name: {{ .Values.global.secretName }}
                  key: smtp-from-address
            - name: MAILER_TO
              valueFrom:
                secretKeyRef:
                  name: {{ .Values.global.secretName }}
                  key: smtp-to-bi
            - name: STORAGE_ATTACHMENTS_PATH
              value: "attachments"
            - name: STORAGE_THUMBNAILS_PATH
              value: "thumbnails"
            - name: STORAGE_ENABLED
              value: {{ if eq (index .Values $appSection "azure" "enabled") true -}}"true"{{- else }}"false"{{- end }}
            - name: STORAGE_FILE_MAX_SIZE_IN_B
              value: "5242880"
          resources:
            {{ index . "Values" $appSection "resources" | toYaml | nindent 12 }}
          securityContext:
            allowPrivilegeEscalation: false
            runAsNonRoot: true
            runAsUser: 1001
            capabilities:
              drop: [ "all" ]
          {{- with index . "Values" $appSection "probes" }}
          {{- if .enabled }}
          readinessProbe: {{ .readinessProbe | toYaml | nindent 12 }}
          livenessProbe: {{ .livenessProbe | toYaml | nindent 12 }}
          {{- end }}
          {{- end }}
{{- end }}
